/* chatch.c */
/* Jed Margolin 1998 */
/* Put out some cross hatch and dot patterns */

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <process.h>
#include <graphics.h>
#include <math.h>

#define SCOLOR 15
#define FALSE (0) 
#define	TRUE  (1) 
#define NUMLINES 25
#define NUMCOLS 80
#define RETURN 13  
#define UPARROW 72 
#define DOWNARROW 80
#define ESC 27
#define FF 13
#define CR 10
#define LEFTARROW 75 
#define RIGHTARROW 77
#define CTL_LEFTARROW 115
#define CTL_RIGHTARROW 116
#define PgUp 73
#define PgDn 81

extern void border(void),box(int,int,int,int,int);
extern void border(void);
extern void wait_for_retrace(void);

void chatch(void),dots(void),hvtest(void);
void draw_hatch(int),draw_dots(int);
/* ======================================================================== */
/* ======================================================================== */
void chatch()
{
   int driver, mode, scolor, bkcolor, dquit;
   char c;
/*------------------------------------------------------------------------- */
   clrscr();
/*------------------------------------------------------------------------- */
/* Initialize Graphics */
   driver = VGA;
   mode = VGAHI;
   registerbgidriver(EGAVGA_driver);
   registerbgifont(small_font);

   initgraph(&driver, &mode, "");

   settextstyle(SMALL_FONT,HORIZ_DIR,0);
   setusercharsize(3,3,3,3);
/* ------------------------------------------------------------------------ */
   scolor = GREEN;
   bkcolor = BLACK;

   cleardevice();
   setbkcolor(bkcolor);
   draw_hatch(scolor);

   setcolor(WHITE);
   border();
/* --------------------------------------------------------------------- */
/* Read and process keyboard */
   dquit = 0;

   while(!(dquit))
   {
		setcolor(scolor);
		wait_for_retrace();

      if( kbhit() )
      {
         c = getch() ;
         if (!c) c = getch() ;	/* get second byte if cursor key */
         switch (c)
         {
	    case UPARROW :
	      scolor++;
	      scolor = scolor&0x0F;
	      break ;

	    case DOWNARROW :
	      scolor--;
	      scolor = scolor&0x0F;
	      break ;

	    case PgUp :
	      bkcolor++;
	      bkcolor = bkcolor&0x0F;
	      setbkcolor(bkcolor);
	      break ;

	    case PgDn :
	      bkcolor--;
	      bkcolor = bkcolor&0x0F;
	      setbkcolor(bkcolor);
	      break ;

            case RETURN :
	      dquit = TRUE;
	      break ;

	    case ESC :
	      dquit = TRUE;
	      break ;
         }				/* end of switch */
	 
	 cleardevice();
	 setbkcolor(bkcolor);
	 draw_hatch(scolor);

         setcolor(WHITE);
         border();
     }					/* end if */

   }					/* end while */
/* ---------------------------------------------------------------------- */
   restorecrtmode();
}
/* ====================================================================== */
void draw_hatch(int color)
{
   int n;
   int startx, starty, endx, endy;

   setcolor(color);

// horizontal lines
   startx = 0;
   endx = 639;
   starty = 0;
   for(n=0; n<12; n++)
   {
      endy = starty;
      line(startx, starty, endx, endy);
      starty = starty + 40;
   }

// vertical lines
   starty = 0;
   endy = 479;
   startx = 0;

   for(n=0; n<16; n++)
   {
      endx = startx;
      line(startx, starty, endx, endy);
      startx = startx + 40;
   }
}
/* ====================================================================== */
void hvtest()
{
   int driver, mode, scolor, bkcolor, dquit, timer;
   unsigned char c;
/*------------------------------------------------------------------------- */
   clrscr();
/*------------------------------------------------------------------------- */
/* Initialize Graphics */
   driver = VGA;
   mode = VGAHI;
   registerbgidriver(EGAVGA_driver);
   registerbgifont(small_font);

   initgraph(&driver, &mode, "");

   settextstyle(SMALL_FONT,HORIZ_DIR,0);
   setusercharsize(3,3,3,3);
/* ------------------------------------------------------------------------ */
   scolor = GREEN;
   bkcolor = BLACK;

   timer = 20;
/* --------------------------------------------------------------------- */
/* Read and process keyboard */
   dquit = 0;

   while(!(dquit))
   {
      setcolor(scolor);
      wait_for_retrace();

      if(timer-- == 0)
      {
         cleardevice();
         setbkcolor(WHITE);
         draw_hatch(BLUE);
         setcolor(BLUE);
         border();
	 timer = 20;
      }
      if(timer == 10)
      {
         cleardevice();
         setbkcolor(bkcolor);
         draw_hatch(scolor);
         setcolor(WHITE);
         border();
      }

      if( kbhit() )
      {
         c = getch() ;
         if (!c) c = getch() ;	/* get second byte if cursor key */
         switch (c)
         {
	    case UPARROW :
	      scolor++;
	      scolor = scolor&0x0F;
	      break ;

	    case DOWNARROW :
	      scolor--;
	      scolor = scolor&0x0F;
	      break ;

	    case PgUp :
	      bkcolor++;
	      bkcolor = bkcolor&0x0F;
	      setbkcolor(bkcolor);
	      break ;

	    case PgDn :
	      bkcolor--;
	      bkcolor = bkcolor&0x0F;
	      setbkcolor(bkcolor);
	      break ;

            case RETURN :
	      dquit = TRUE;
	      break ;

	    case ESC :
	      dquit = TRUE;
	      break ;
         }				/* end of switch */
     }					/* end if */
   }					/* end while */
/* ---------------------------------------------------------------------- */
   restorecrtmode();
}
/* ====================================================================== */
/* ======================================================================== */
void dots()
{
   int driver, mode, scolor, bkcolor, dquit;
   char c;
/*------------------------------------------------------------------------- */
   clrscr();
/*------------------------------------------------------------------------- */
/* Initialize Graphics */
   driver = VGA;
   mode = VGAHI;
   registerbgidriver(EGAVGA_driver);
   registerbgifont(small_font);

   initgraph(&driver, &mode, "");

   settextstyle(SMALL_FONT,HORIZ_DIR,0);
   setusercharsize(3,3,3,3);
/* ------------------------------------------------------------------------ */
   scolor = WHITE;
   bkcolor = BLACK;

   cleardevice();
   setbkcolor(bkcolor);
   draw_dots(scolor);
/* --------------------------------------------------------------------- */
/* Read and process keyboard */
   dquit = 0;

   while(!(dquit))
   {
      setcolor(scolor);
      wait_for_retrace();

      if( kbhit() )
      {
         c = getch() ;
         if (!c) c = getch() ;	/* get second byte if cursor key */
         switch (c)
         {
	    case UPARROW :
	      scolor++;
	      scolor = scolor&0x0F;
	      break ;

	    case DOWNARROW :
	      scolor--;
	      scolor = scolor&0x0F;
	      break ;

	    case PgUp :
	      bkcolor++;
	      bkcolor = bkcolor&0x0F;
	      setbkcolor(bkcolor);
	      break ;

	    case PgDn :
	      bkcolor--;
	      bkcolor = bkcolor&0x0F;
	      setbkcolor(bkcolor);
	      break ;

            case RETURN :
	      dquit = TRUE;
	      break ;

	    case ESC :
	      dquit = TRUE;
	      break ;
         }				/* end of switch */
	 
	 cleardevice();
	 setbkcolor(bkcolor);
	 draw_dots(scolor);
      }					/* end if */

   }					/* end while */
/* ---------------------------------------------------------------------- */
   restorecrtmode();
}
/* ====================================================================== */
void draw_dots(int color)
{
   int m,n;
   int xpos, ypos;

//   setcolor(color);

// do the vertical columns of dots
   ypos = 0;
   for(m=0; m<13; m++)
   {
      // do a horizontal row of dots
      xpos = 0;
      for(n=0; n<18; n++)
      {
	 putpixel(xpos,ypos,color);
	 xpos = xpos + 39;
      }

      ypos = ypos + 39;
   }
}
/* ====================================================================== */
